#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "liblihata/dom.h"
#include "liblihata/tree.h"
#include "lht_marshaller.h"

typedef struct blobb_s {
	int i;
	double d;
	float f;
	char *s;
} blobb_t;

void print_blobb(blobb_t *b)
{
	printf("blobb %p: i=%d d=%f f=%f s='%s'\n", b, b->i, b->d, b->f, b->s);
}

int main()
{
	lht_doc_t *doc;
	lht_node_t *node, *blobb_desc;
	blobb_t b1, b2;

	char *err;
	doc = lht_dom_load("test_struct.lht", &err);
	if (doc == NULL) {
		fprintf(stderr, "Error loading test_struct.lht: %s\n", err);
		return 1;
	}

	blobb_desc = lht_dom_hash_get(doc->root, "blobb_s");

	b1.i = 42;
	b1.d = 3.1415;
	b1.f = 3.14;
	b1.s = "hello world!";
	print_blobb(&b1);

	node = lht_marshaller_b2l(blobb_desc, NULL, &b1);
	printf("b1:\n");
	lht_dom_ptree(node, stdout, "  ");


	memset(&b2, 0, sizeof(b2));
	lht_marshaller_l2b(blobb_desc, &b2, node);
	printf("b2:\n");
	lht_dom_ptree(node, stdout, "  ");
	print_blobb(&b2);

	lht_dom_uninit(doc);
	return 0;
}
