%{
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "liblhtview.h"
	extern lhtview_t *ctx;

	static const char *arg(int offs)
	{
		char *ret, *end;
		
		ret = yytext + offs;
		while(isspace(*ret)) ret++;
		for(end = ret; (*end != '\r') && (*end != '\n') && (*end != '\0'); end++) ;
		*end = '\0';
		return ret;
	}

	extern void prompt(lhtview_t *ctx);
%}

%%
ls[ \t]+[-]l[ \t]\n {
                    	if (lhtview_cmd_ls(ctx, stdout, NULL, 0))
                    		printf("Error: can not list\n");
                    	prompt(ctx);
                    }
ls[ \t]+.+\n        { abort(); }
ls[ \t]*\n          {
                    	if (lhtview_cmd_ls(ctx, stdout, NULL, 0))
                    		printf("Error: can not list\n");
                    	prompt(ctx);
                    }
cd[ \t]*\n          { abort(); }
cd[ \t]+.+\n        {
                    	int err;
                    	if (lhtview_cmd_cd(ctx, arg(2), &err) != 0)
                    		printf("Error: %s\n", lht_err_str(err));
                    	prompt(ctx);
                    }
load[ \t]+.+\n      {
                    	char *errmsg;
                    	if (lhtview_cmd_load(ctx, arg(4), &errmsg) != 0)
                    		printf("Error: %s\n", errmsg);
                    	prompt(ctx);
                    }
[ \t]*\n            { prompt(ctx); }
exit[ \t]*\n        { return -1; }
<<EOF>>             { return -1; }

.*\n                { printf("Error: invalid command\n"); prompt(ctx); }
%%
