#include <stdio.h>
#include "liblihata/dom.h"

typedef struct lhtview_s {
	lht_doc_t *doc;
	lht_node_t *cwd;
	int quiet;
} lhtview_t;

/* Allocate a new empty lhtview_t context */
lhtview_t *lhtview_init(int quiet);

/* Free a context and all memory associated */
void lhtview_uninit(lhtview_t *ctx);


/* Load a document in a context - fails if the context already has a document
   loaded. cwd is set to the document root.
   Returns 0 on success, -1 on failure (and loads the malloc()'ed error message
   in errmsg if errmsg is not NULL) */
int lhtview_cmd_load(lhtview_t *ctx, const char *fn, char **errmsg);

/* Change cwd to path. Path may be relative or absolute.
   Returns 0 on success, -1 on failure (in which case cwd is left untouched) */
int lhtview_cmd_cd(lhtview_t *ctx, const char *path, lht_err_t *err);

/* List children of cwd (non-recursive). If long_format is:
    - 0: one node name per line;
    - 1: type name, space, node name per line
   Returns 0 on success, -1 on failure (in which case cwd is left untouched) */
int lhtview_cmd_ls(lhtview_t *ctx, FILE *fout, const char *path, int long_format);

