/* This file is placed in the public domain by its
   author Tibor 'Igor2' Palinkas in 2013. Feel free to
   copy and extend it in case you need event based lihata
   parsing with validation. */

#include <stdlib.h>
#include <stdio.h>
#include "liblihata/parser.h"
#include "lib_validator.h"

void event(lht_parse_t *ctx, lht_event_t ev, lht_node_type_t nt, const char *name, const char *value)
{
	int *errcnt = ctx->user_data;
	if (ev == LHT_ERROR) {
		fprintf(stderr, "This is not a valid lihata document: %s (at %d:%d)\n", name, ctx->line, ctx->col);
		errcnt++;
	}
	/* we could still process the event here but the sole purpose of this tool
	   is to run the validator */
}

int main(int argc, char *argv[])
{
	lht_parse_t *ctx;
	int errcnt = 0;

	ctx = lht_validator_init(&errcnt, event);
	while(!(feof(stdin))) {
		int c = fgetc(stdin);
		if (lht_parser_char(ctx, c))
			break; /* error or stop, do not read anymore (would get PE_STOP without any processing all the time) */
	}
	lht_validator_uninit(ctx);

	return errcnt;
}
